/* auro_read_zensho_tokumei.sas */ *options nocenter;
/*%let drive=G; *f[^(CSVt@C)ۑĂhCu;*/
/*%let path        =&drive:\S\Sf[^\\;      *\̂tH_̕ۑꏊ;*/
/*%let tokumei_path=&drive:\S\Sf[^\Sf[^; *f[^(CSVt@C)ۑꏊ;*/
/*%let SASds_path  =&drive:\S\Sf[^\Sf[^\SASds;       *SAS datasetۑꏊ;*/
/*%let SASpgm      =&drive:\S\Sf[^\program;                *SAS programۑꏊ;*/

libname zensho "&SASds_path";

%macro read_zensho_fugohyo_program(year,H_year,which,F_T);
*Sf[^ǍSASvO̍쐬}N;
filename out&year&F_T "&SASpgm\autoread&year&F_T..sas"; *쐬ǍSASvO;

*\̓ǂݍ ;
proc import out=zensho.zensho_fugohyo&year._&F_T
  datafile="&fugohyo_path\&year\tokumei_zen&H_year._&which..xls"
  dbms=excel replace;
  getnames=no;
  sheet=\;
run;
*\SASf[^Zbg̐`;
data zensho.zensho_fugohyo&year._&F_T; *ϐF1`F15쐬;
  set; if _N_ >= 9; *observations 1`8폜;run;

proc print data=zensho.zensho_fugohyo&year._&F_T;
  title "Sf[^E\F&year&which (1)"; run;

data zensho.zensho_fugohyo&year._&F_T;
  set; if F2="," then delete; run;

proc print data=zensho.zensho_fugohyo&year._&F_T;
  title "Sf[^E\F&year&which (2)"; run;
*;
data program (keep=label at len type F5);
  *f[^ǂݍSASvO쐬ɕKvȏ̎擾;
  *ϐx,JnJʒu,,ϐ^,ϐԍ;
  set zensho.zensho_fugohyo&year._&F_T;
  if F4 NE " " AND F6 NE " "
     then do; label=F2; at=F4; len=F6;
              if F9="1" then type=" "; else type="$";
              output;
          end;
run;

proc print data=program;
  title "Sf[^ǂݍ݃vOp(0)F&year&F_T"; run;
*f[^ǂݍSASvO쐬Jn;
*infileinput쐬;
data x1 (keep=program_code); set program end=final;
  length var_No $ 4; *ő9999̕ϐɑΉ\;
  length program_code $ 200;
  if _N_=1 then program_code=
      "data zensho.xzensho&year&F_T; infile inX; idno+1; input "; output;
  var_No=F5; upto=at+len-1;
  program_code=compress("var" || var_No) || " " || type || " " || compress(at  || "-" || upto);
  output; *\ɂ͕ϐ̗Ȃ̂ŁA쐬ϐ́uvar1, var2, vƂ;
  if final then do; program_code=";"; output; end;
run;

proc print data=x1;
  title "f[^ǂݍ݃vOp(1)F&year&F_T"; run;
*x쐬;
data x2 (keep=program_code); set program end=final;
  length var_No $ 4; *ő9999̕ϐɑΉ\;
  length program_code $ 200;
  if _N_=1 then do; program_code="label "; output; end;
  var_No=F5;
  program_code=compress("var" || var_No) || '=' || compress('"' || label || '"');
  output; 
  if final then do; program_code="; run;"; output; end; *data step̍Ōrun;
run;

proc print data=x2;
  title "f[^ǂݍ݃vOp(2)xF&year&F_T"; run;
*filename쐬;
data FLname; length program_code $ 200;
  program_code='filename inX "&tokumei_path\&year.zensyou_&F_T..csv";';
run;
*filenameinfileinputx̍āAǂݎvO;
data x3; file out&year&F_T; set FLname x1 x2; put program_code; run;

proc print data=x3;
  title "f[^ǂݍ݃vSASOF&year&F_T"; run;

%include "&SASpgm\autoread&year&F_T..sas";*ǂݎvOs;
%mend;

%read_zensho_fugohyo_program(1994,H6, ippan,  F)
%read_zensho_fugohyo_program(1994,H6, tanshin,T)
%read_zensho_fugohyo_program(1999,H11,ippan,  F)
%read_zensho_fugohyo_program(1999,H11,tanshin,T)
%read_zensho_fugohyo_program(2004,H16,futari, F)
%read_zensho_fugohyo_program(2004,H16,tanshin,T)

*1994N,1999N,2004Nf[^pproc formatSAS programۑꏊɎ쐬B    ;
*쐬vO:@tokumeiFormat1994.sas, AtokumeiFormat1999.sas, BtokumeiFormat2004.sas;
%macro format(year,F_T);
filename out3 "&SASpgm\tokumeiFormat&year..sas";

proc print data=zensho.zensho_fugohyo&year._&F_T; where F9 NE " ";
  title "data=zensho.zensho_fugohyo&year._&F_T: F9(ϐ̌^ulvj\"; run;

data format;
    keep formatName F2 F5 F9 F13 F14;
                  * F2=ږ(ϐx), F5=ڔԍ, F9=^,F13=(R[hl), F14=e;
    rename          F2=Vlabel              F13=Vcode           F14=VcodeContents;
    set  zensho.zensho_fugohyo&year._&F_T; *\̃f[^Zbggp;
    retain formatName;
    length formatName $ 10;
    length varNo $ 4;
                                          
    if F5 NE " " then do; varNo=F5; variable="VAR" || varNo; end;                
    if (varNo NE " " AND F9=" ") OR (varNo NE " " AND F8=" ")
        then do; formatName=variable; output; return; end;
    if varNo NE " " then formatName=variable;
    if F2=" " then output;
run;

proc print; title "D-1 formatΏەϐ(1) &year"; run;

proc freq data=format; tables Vcode; title "Sf[^:\̃R[hl̃`FbN"; run;

data chk; set format; if Vcode="X" OR Vcode="V" OR Vcode=""; run;
proc print; title "Sf[^:\̃R[hl(XVƁ)̃`FbNF &year"; 
  var Vlabel Vcode VcodeContents;
run;

*====== datasetuformatvɑ΂āAuVvƁuv̏ǉ======;
data format; set format;
    serialNo+1;
    if index(Vcode,"V") > 0 then Vcode=".";
    Vcode=KTRANSLATE(Vcode, " ", "");
run;
proc print; title "D-2 V converted to period"; run;

proc sort data=format; by formatName; run;

data format; set format; by formatName;
    if first.formatName=1 AND last.formatName=1 then delete;
run;

proc sort data=format; by serialNo; run;
proc print; title "̏ɖ߂ĊmF"; run;
*====== datasetuformatvɑ΂uVvƁuv̒ǉI==========;

proc sort data=format out=format1; by formatName; run;
proc print; title "sorted by formatName"; run;

data format1; set format1; by formatName;
    retain vartype;
    xformatName=formatName; *byϐp;
    if first.formatName
       then do; if F9=" " then do; vartype="char"; formatname='$' || formatname; end;
                          else     vartype="nume";
                statement2='value ' || 
                           compress(formatName || '_' || &year || 'X') || ' ' || 
                          kcompress('/* ' || Vlabel || ' */');
            end;
    if vartype="char" then Vcode=compress('"' || Vcode || '"');
                      else do; if Vcode=" " then Vcode="."; end;
    statement=kcompress(Vcode || '="' || VcodeContents || '"');
run;

proc print;
    title "D-3 formatΏەϐ(2)";
    var xformatName formatName Vcode VcodeContents statement statement2 serialNo;
run;
    
data _null_; file out3;
    set format1 end=final; by xformatName;
    if _n_=1 then put "proc format; *SEf[^ &year;";
    if first.xformatName then put statement2;
    if last.xformatName  then put "    " statement ";" /;
                        else put "    " statement;
    if final then put "run;";
run;
%mend;

%format(1994,F)
%format(1999,F)
%format(2004,F)
