/* ϐƃx̏.sas */ options nocenter; *options macrogen;
/*%let drive=G; *f[^(CSVt@C)ۑĂhCu;*/
/*%let path        =&drive:\S\Sf[^\ϐƃx;*tH_ϐƃxpathݒ;*/
/*%let tokumei_path=&drive:\S\Sf[^\Sf[^; *f[^(CSVt@C)ۑꏊ;*/
/*%let SASds_path  =&drive:\S\Sf[^\Sf[^\SASds;        *SAS datasetۑꏊ;*/
/*%let SASpgm      =&drive:\S\Sf[^\program;                *SAS programۑꏊ;*/

libname zensho "&SASds_path";

%macro read_var_label_Excel(year,F_T);

*ϐƃxf[^(Excelt@C)̓ǂݍ ;
proc import out=meta
  datafile="&path\&year\&year.zensho_&F_T._vname.csv" dbms=csv replace;
  getnames=no; datarow=2; *Psڂ͖; guessingrows=32767;
run; *ϐvar1(ڔԍ), var2(ϐ), var3(ږ:ϐx)쐬;

data meta (keep=varNo vname vlabel); set meta; rename var3=vlabel;
  length vNo $ 10; vNo=var1; variableNo=compress("var" || vNo); *ϐv0001,v0002,v1,v2;
  length vname $ 13; vname=right(variableNo);
  varNo=var1;
run;

/*proc print; title "ϐƃx:&year:&F_T (1)"; var varNo vname vlabel; run;*/

data meta (keep=varNo vlabel vname  repeatNo Llabel Rlabel);
  length repeatNo 4; *l^ϐ;
  set meta; find=index(vlabel,")_"); *u)_vT;
  if find > 0 then do; Rlabel=vlabel; substr(Rlabel,1,find+1)=" ";
                       Rlabel=left(Rlabel); *u)_v̉E̕񂾂o;
                       do i=find to 1 by -1;
                          if substr(vlabel,i,1)="(" then do; len=find-i-1;
                                                             repeatNo=substr(vlabel,i+1,len);
                                                             Llabel=substr(vlabel,1,i-1);
                                                         end;
                       end; *ϐrepeatNol̏ꍇ́AYϐ(var?)͌JԂϐłȂ;
                   end;
              else Rlabel=vlabel;

/*proc print; title "data=meta: ϐƃx:&year:&F_T (2)"; */
/*  var varNo vlabel vname  repeatNo Llabel Rlabel; run;*/

data meta2; set meta; if repeatNo > 0; run;

/*proc print; title "data=meta2: ϐƃx:&year:&F_T (3)"; */
/*  var varNo vlabel vname  repeatNo Llabel Rlabel; run;*/

data fugohyo; set zensho.zensho_fugohyo&year._&F_T;
  length varNo 4; *l^(ϐԍ);
  varNo=F5; if varNo > 0; run;

proc print; title "data=fugohyo"; run;

data mergeDS; rename F4=at F6=len F9=var_type;
  merge meta2 fugohyo; by varNo;
  if repeatNo > 0; *JԂϐ̂ݕۑ;
run;

%let maxNo=700; *JԂϐ̌A]TāA߂ɐݒ;

data repeat_var; keep varNo vlabel vname repeatNo Llabel Rlabel at len var_type;
  set mergeDS;

  array xlen      {&maxNo} $  8  ;
  array xvar_type {&maxNo} $  2  ;

  retain xlen1-xlen&maxNo xvar_type1-xvar_type&maxNo; 
  retain xrepeatNo -1;
  retain sw 0;
  
  if repeatNo NE xrepeatNo then k=0;
  if sw=0 AND repeatNo=1 then 
        do; i=0; k=0; sw=1;
            do j=1 to &maxNo; xlen{j}=" "; xvar_type{j}=" "; end;
        end;

  if repeatNo=1 then do; i+1;       xlen{i}=len; xvar_type{i}=var_type; end;
                else do; sw=0; k+1; len=xlen{k}; var_type=xvar_type{k}; end;
  xrepeatNo=repeatNo;
run; 

/*proc print; title "JԂϐ:&year:&F_T (2)"; */
/*  var varNo vlabel vname repeatNo Llabel Rlabel at len var_type; run;*/

data zensho.repeat_var_table&year&F_T; set;
  *SĂ̌JԂϐ̕ϐ(vname,)Jʒu(at),(len),ϐ^(var_type)̍Č;
  retain next_at "          ";
  if repeatNo > 1 then at=next_at;
  next_at=at+1+len;
run;  

/*proc print; title "JԂϐ:&year:&F_T (3)"; */
/*  var varNo vlabel vname repeatNo Llabel Rlabel at next_at len var_type; run;*/

*f[^(JԂϐ)ǂݍSASvO쐬Jn;
*infileinput쐬;
data x1 (keep=program_code); set zensho.repeat_var_table&year&F_T end=final;
  length program_code $ 200;

  if _N_=1 then do; program_code="data zensho.repeat&year&F_T;
                                  infile inX; idno=_N_; input "; output; end;

  upto=at+len-1;
  if var_type="1" then type=" "; else type="$";
  program_code=vname || " " || type || " " || compress(at  || "-" || upto);
  output; *쐬ϐ́uvar40, var41, v̗lɂȂ;
  if final then do; program_code="; run;"; output; end;
run;

/*proc print data=x1;*/
/*  title "f[^ǂݍ݃vOp(1)F&year&F_T"; run;*/

*filename쐬;
data FLname; length program_code $ 200;
  program_code='filename inX "&tokumei_path\&year.zensyou_&F_T..csv";';
run;
*filenameƁuinfileinputv̍āAǂݎvO;
filename out&year&F_T "&SASpgm\repeatread&year&F_T..sas";

data RepeatVarProgram&year&F_T; file out&year&F_T; set FLname x1; put program_code; run;

proc print;
  title "f[^(JԂϐ)ǂݍ݃vSASOF&year&F_T"; run;

%include "&SASpgm\repeatread&year&F_T..sas";*ǂݎvOs;
%mend;

%read_var_label_Excel(1994,T);
%read_var_label_Excel(1994,F);

%read_var_label_Excel(1999,T);
%read_var_label_Excel(1999,F);

%read_var_label_Excel(2004,T);
%read_var_label_Excel(2004,F);
