/* JԂϐ.sas */ options nocenter macrogen;
/*%let drive       =F; *f[^(CSVt@C)ۑĂhCu;*/
/*%let path        =&drive:\S\Sf[^\ϐƃx;*tH_ϐƃxpathݒ;*/
/*%let tokumei_path=&drive:\S\Sf[^\Sf[^; *f[^(CSVt@C)ۑꏊ;*/
/*%let SASds_path  =&drive:\S\Sf[^\Sf[^\SASds;       *SAS datasetۑꏊ;*/
/*%let SASpgm      =&drive:\S\Sf[^\program;                *SAS programۑꏊ;*/

libname zensho "&SASds_path";

%macro reformRepeat(year,F_T);
filename out2 "&SASpgm\reformRelationalDB&year&F_T..sas"; 
*JԂϐ̃f[^Zbg쐬SASvO;

proc sort data=zensho.repeat_var_table&year&F_T out=repeatTB;
  by Llabel descending repeatNo descending varNo; run;

/*proc print data=repeatTB (obs=200); title "after sort: &year&F_T"; run;*/

data repeatVar; set repeatTB (drop=at next_at); by Llabel descending repeatNo;
  if first.Llabel then do; variableNo=0; end;
  variableNo+1; 
  if last.repeatNo;
run;

/*proc print data=repeatVar; title "List of all Llabel: &year&F_T"; run;*/

data repeatVar (drop=variableNo); set; by Llabel; retain howmanyVar;
  if first.Llabel then howmanyVar=variableNo;
run;

proc sort; by varNo; run; *̏ɖ߂;

/*proc print; title "data=repeatVar  List of all Llabel sorted by varNo: &year&F_T"; run;*/

data repeatVar; set; retain prev_Llabel;
  if Llabel NE prev_Llabel then do; LlabelNo+1; prev_Llabel=Llabel; end; run;

/*proc print;*/
/*  title "data=repeatVar  List of all Llabel sorted by varNo: &year&F_T with LlabelNo"; run;*/

data findRepeat (keep=vname varNo HowmanyVar LlabelNo); set repeatVar; by LlabelNo;
  if first.LlabelNo; run;

proc print; title "data=findRepeat: All repeated variables: &year&F_T"; run;

data keepVarList; set findRepeat; length endNo $ 5; endNo=varNo+howmanyVar-1;
  keepCode="keep " || compress(vname || "-" || "var" || endNo || ";");
run; * keep쐬;

proc print; title "data=keepVarList: keep All repeated variables: &year&F_T";
  var keepCode; run;

data giveLabel; set; length programCode $ 500;
*JԂϐ̕ϐxp߂ɁA{̂̃f[^Zbg̍ŏobservationo;
  length xLlabelNo $ 5; xLlabelNo=LlabelNo; *l^LlabelNo^;
  programCode="data " || compress("getLabel" || xLlabelNo) || ";";           output;
  programCode="set "  || compress("zensho.xzensho" || "&year&F_T") || ";";   output;
  programCode=keepCode;                                                      output;
  programCode="if _N_=1; run; *;";                                         output;

  *ō쐬f[^ZbggetLabel???permanent DS(RDB1994???)cɕ;
  programCode="data " || compress("zensho.xRDB" || "&year&F_T" || xLlabelNo) || ";";    output;
  programCode="set  " || compress("getLabel"    || xLlabelNo)  || " " 
                      || compress("zensho.RDB"  || "&year&F_T" || xLlabelNo) || "; run;*;"; output;
  programCode="data " || compress("zensho.xRDB" || "&year&F_T" || xLlabelNo) || ";";    output;
  programCode="set; if _N_=1 then delete; run; *;" ;                                  output;

  *ȉproc print̓xt^Õf[^Zbg\B쐬xRDB???Ƃ̔rmFp;
  programCode="proc print data=" || compress("zensho.RDB" || "&year&F_T" || xLlabelNo)|| "(obs=10);";
               output;
  programCode=
  "title '" || compress("zensho.RDB" || "&year&F_T" || xLlabelNo) || "(obs=10)ϐxȂ'; run; *;";
               output;
run;

proc print; title "data=giveLabel: JԂϐɕϐxt^: &year&F_T";
  var programCode; run;

data _null_; set giveLabel; file out2; put programCode; run;

%include "&SASpgm\reformRelationalDB&year&F_T..sas";
%mend;

data _null_; startTime=time(); put " sJn  " startTime TIME.; run;

%reformRepeat(1994,T);
%reformRepeat(1994,F);
%reformRepeat(1999,T);
%reformRepeat(1999,F);
%reformRepeat(2004,T);
%reformRepeat(2004,F);

data _null_; endTime=time();   put " sI  " endTime TIME.; run;
